#include "lx_imath.hpp"  //extended staggered intervals
using namespace std;
using namespace cxsc;

int main() {
   stagprec= 5;                        //5-fold double precision
   int sixHundredMillion(600000000);
   lx_interval n, r;
   n= lx_interval(sixHundredMillion,"[1,1]");
   //n now equals 10^600.000.000
  
   r= xp1_pow_y(1/n,n);                //(*)  
   cout << "(1+1/n)^n: " << r << endl;
   cout << "with Relative diameter: " << RelDiam(r) << endl;
   
   stagprec= 20;                       //20-fold double precision
   //use predefined constant E_lx_interval() for exp(1)
   lx_interval Euler(E_lx_interval()); //enclosure of exp(1) 
   
   n= lx_interval(300, "[1,1]");       //10^300
   r= pow(1+1/n, n);                   //r= (1+1/10^300)^(10^300)
   cout << "Enclosure of displacement e-r: ";
   cout << Euler-r << endl;
   cout << "with relative diameter: " << RelDiam(Euler-r) << endl;
   return 0;
}   

/*
(1+1/n)^n: { 10**(-306)*[2.7182818284E+0306,2.7182818285E+0306] }
with Relative diameter: { 10**(-386)*3.4128669415E+0306 }
Enclosure of displacement e-r: { 10**(-607)*[1.3591409118E+0307,1.3591409147E+0307] }
with relative diameter: { 10**(-315)*2.0778584011E+0306 }
*/
